ALTER PROCEDURE [dbo].[P_SMS_Ptr] (@R int=null,@ZAKAZ int=null, @COD varchar(4000)=NULL OUTPUT,
@EncryptPassword nvarchar(4000)=NULL,@Name varchar(128)=null,@Type int=null OUTPUT,
@TIMETOCLIENT int=null)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <10/02/2010>
-- Create date: <22/06/2016>
-- Description:	<  WEB >
-- =============================================
	SET DATEFORMAT dmy;
	SET NOCOUNT ON;
	DECLARE @PhonePrefix varchar(20)=NULL;
	--          
	if @R=3
		begin
			--      
			UPDATE BASE SET TimeToClientUpdate=GETDATE(), TIMETOCLIENT=@TIMETOCLIENT WHERE UniKey=@ZAKAZ;
			DECLARE @SMS_Pattern_link int, @JSendSMSTimeToClient bit=0, @JSendAudioTimeToClient bit=0,
				@JSendAudioTimeToClientPattern int=NULL, @isAudioRobotEnabled bit=1, @OtkazClienta int=0,
				@isOnlyPhoneType bit=0, @PhoneTypePattern int=0,@ZakazPlace int,@LPSrc int,
				 @SmsText varchar(512),@PhoneType int, @SMS int,@isOtkazClienta bit, @PhoneKey int, @CLIENTTEL varchar(20);
			SET @SMS_Pattern_link=NULL;
			SELECT TOP 1 @JSendSMSTimeToClient=PP.JSendSMSTimeToClient,
				@JSendAudioTimeToClient=JSendAudioTimeToClient FROM PROPERTIES PP;
			--     
			if (@JSendSMSTimeToClient=1) OR
				(@JSendAudioTimeToClient=1)
				begin
				SELECT @CLIENTTEL=bbb.CLIENTTEL,@PhoneKey=PhoneKey, @OtkazClienta=OtkazClienta FROM BASE bbb WHERE UNIKEY=@ZAKAZ;
				--   -  
				SET @PhoneType=NULL;
				if(@PhoneKey IS NULL)
					SELECT @PhoneType=PhoneType,@isAudioRobotEnabled=BL.isAudioRobotEnabled FROM BLACKLISTTEL BL WITH (nolock) WHERE BL.NUMTEL=@CLIENTTEL;
					ELSE
					SELECT @PhoneType=PhoneType,@isAudioRobotEnabled=BL.isAudioRobotEnabled FROM BLACKLISTTEL BL WHERE BL.UniKey=@PhoneKey;					
				if (@PhoneType IS NULL) 
					begin 
					SET @PhoneType=dbo.isPhoneInternational(@ClientTel);
					SET @isAudioRobotEnabled=1;
					end;
				end;
			
			-- . 
			if (@JSendSMSTimeToClient=1) AND (@PhoneType=0)
				begin				
				--@SMS_Pattern_link=PP.JSendSMSTimeToClientPattern
				SELECT @ZakazPlace=ZakazPlace,@LPSrc=LPSrc FROM BASE WITH(readpast) WHERE UniKey=@Zakaz
				-- 
				SET @SMS_Pattern_link=[dbo].[F_GET_SMS_PATTERN_OUT_BY_ORDER](@Zakaz,1,@ZakazPlace,NULL);
				IF (@SMS_Pattern_link IS NOT NULL)
					begin
					SET @SmsText=[dbo].[GetSMSTextByPattern](@ZAKAZ,@SMS_Pattern_link);				 
					--     SMS
					INSERT INTO SMS (SmsState,SmsText,Phone,InOut,Priority) VALUES (2,@SmsText,
						[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,1,NULL,NULL,NULL),1,1);
					SET @SMS=SCOPE_IDENTITY();
					INSERT INTO SMSZakazLink (zakaz,sms,UserID) VALUES (@ZAKAZ,@SMS,dbo.GetCurrentUserUniKey());
					--  SMS  
					DECLARE @SMSChannel int=NULL;
					SELECT @SMSChannel=SMSChannel FROM LPSrc WHERE UniKey=@LPSrc;
					if (@SMSChannel IS NOT NULL)
						begin
						UPDATE SMS SET Channel=@SMSChannel WHERE UniKey=@SMS;
						end;
					end;
				end;
			-- 
			--   
			SET @JSendAudioTimeToClientPattern=[dbo].[F_GET_AUDIO_PATTERN_OUT_BY_ORDER](@ZAKAZ,1,1,NULL);
			if (@JSendAudioTimeToClientPattern IS NOT NULL AND @JSendAudioTimeToClient=1 AND @isAudioRobotEnabled=1)
				begin
				SELECT @isOnlyPhoneType=isOnlyPhoneType,@PhoneTypePattern=PhoneType FROM Audio_Patterns WHERE  UniKey=@JSendAudioTimeToClientPattern;
				if (NOT (@isOtkazClienta=1 AND [dbo].[isZakazExitError](@OtkazClienta)=1))
					begin
					if (@isOnlyPhoneType=0 OR @PhoneTypePattern=@PhoneType)
						begin
						--   
						SELECT @PhonePrefix=PhonePrefix FROM LPSrc WHERE UniKey=(SELECT LPSrc from BASE WITH(nolock) WHERE UniKey=@ZAKAZ);
							if (@PhonePrefix IS NOT NULL)
								begin
								SET @PhonePrefix=@PhonePrefix+[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,NULL,1,NULL,NULL);
								end
								else		
								SET @PhonePrefix=[dbo].[GetPhoneFromPatternS](@CLIENTTEL,1,NULL,NULL,1,NULL,NULL);
						
						INSERT INTO PhoneHistoryAutoRobot ([State],InOut,Phone,Zakaz,Audio_Pattern,PhoneKey) VALUES
							(6,1,@PhonePrefix,@ZAKAZ,@JSendAudioTimeToClientPattern,@PhoneKey);
						end;
					end;
				end;
			--   ,     
		DECLARE @UltraKey int,@isOwn bit,@Driver int, @UltraExchange int;
		SELECT @UltraKey=UltraKey,@isOwn=isOwn,@Driver=Driver,@UltraExchange=UltraExchange FROM BASE bbb WHERE UNIKEY=@ZAKAZ;
		if (@UltraKey IS NOT NULL) AND (@isOwn=0) AND (@Driver IS NOT NULL)
			begin
			DECLARE @GOV_NUMBER varchar(128),@GOV_NUMBER_Short varchar(128),@TMP int;
			SELECT TOP 1 @TMP=TDR.TAXI,@GOV_NUMBER=ccc.GOV_NUMBER,@GOV_NUMBER_Short=ccc.GOV_NUMBER_Short FROM TAXI_DR TDR 
				LEFT JOIN Cars ccc ON TDR.Car=ccc.UniKey
				WHERE  TDR.Driver=@Driver AND (TDR.DATEIN<=GETDATE() AND (TDR.DATEOUT>=GETDATE() OR TDR.DATEOUT IS NULL));			
			exec [dbo].[P_Ultra] @R=3, @OrderId=@UltraKey, @StatusId=@TMP, @Command=3, @Price=0, @ToCarMin=@TIMETOCLIENT,
				@VarChar1=@GOV_NUMBER, @VarChar2=@GOV_NUMBER_Short, @UltraExchange=@UltraExchange;
			end;			
			return;
		end;	
	--      
	if @R=4
		begin
		UPDATE BASE SET TimeToClientUpdate=GETDATE(), TIMETOCLIENT=@TIMETOCLIENT WHERE UniKey=@ZAKAZ;
		return;
		end;
	if @R=1
		begin
		IF EXISTS(SELECT [NAME] FROM S_OBJECTS WHERE [NAME]=@Name)
			DELETE FROM S_OBJECTS WHERE [NAME]=@Name;
		INSERT INTO S_OBJECTS ([NAME],[TYPE],[Value]) VALUES (@Name,@Type,@COD);
		end;
	if @R=2
		begin
		SELECT @COD=[Value],@Type=[TYPE] FROM S_OBJECTS WHERE [NAME]=@Name;
		end;
	if @R=7 
		begin
		DECLARE @VarBin varbinary(8000);
		SET @VarBin=ENCRYPTBYPASSPHRASE(@EncryptPassword,@COD);
		SELECT @COD=upper(substring(master.sys.fn_varbintohexstr(@VarBin),3, 2*len(@VarBin)));
		end;
END
