ALTER FUNCTION [dbo].[F_CHECK_CONDITION_ORDER_PARAM]
(@CoreKey int,		-- 
@CoreTypeKey int,	-- 
@ModuleType int, @Driver int,  @LPSrc int, 
@isInterCity bit, @isPredv bit, 
@isTaximeter bit, @isSpecial bit, @CarTypeOrder int, @isError bit
)
RETURNS bit
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <17.05.2016>
-- Update date: <20.06.2016>
-- Description:	< 1,    >
-- =============================================
		--
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=1 AND CAST(ConditionValue as bit)!=@isInterCity AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		--
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=2 AND CAST(ConditionValue as bit)!=@isPredv AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		-- 
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=3 AND CAST(ConditionValue as bit)!=@isTaximeter AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		--   
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=4 AND ConditionValue!=@CarTypeOrder AND CoreTypeKey=@CoreTypeKey)
			AND NOT EXISTS
			(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
				ConditionTypeKey=4 AND ConditionValue=@CarTypeOrder AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		--
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=5 AND CAST(ConditionValue as bit)!=@isSpecial AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		--   
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=8 AND ConditionValue=0 AND CoreTypeKey=@CoreTypeKey AND @Driver IS NOT NULL)
			OR
			EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
				ConditionTypeKey=8 AND ConditionValue=1 AND CoreTypeKey=@CoreTypeKey AND @Driver IS NULL)			
			begin
			return 0;
			end;
		-- 
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=7 AND ConditionValue!=@LPSrc AND CoreTypeKey=@CoreTypeKey)
			AND NOT EXISTS
			(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
				ConditionTypeKey=7 AND ConditionValue=@LPSrc AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;
		--  
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=6 AND ConditionValue!=@ModuleType AND CoreTypeKey=@CoreTypeKey)
			AND NOT EXISTS
			(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
				ConditionTypeKey=6 AND ConditionValue=@ModuleType AND CoreTypeKey=@CoreTypeKey)
			begin
			return 0;
			end;			
		--   
		if EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
			ConditionTypeKey=9 AND ConditionValue=0 AND CoreTypeKey=@CoreTypeKey AND @isError=0)
			OR
			EXISTS(SELECT 1 FROM ConditionsOrder WHERE CoreKey=@CoreKey AND 
				ConditionTypeKey=9 AND ConditionValue=1 AND CoreTypeKey=@CoreTypeKey AND @isError=1)			
			begin
			return 0;
			end;
	RETURN 1


END
