// Copyright 2013 The NooRex. All rights reserved.

var hostName = "com.native.noorex.host";
var port = null;
var port_ext=null;
function onDisconnectedExt() {
  port_ext = null;
  if(!port) port.disconnect;
}

chrome.runtime.onConnectExternal.addListener(function(port_ext1) {
	port_ext=port_ext1;
  console.assert(port_ext1.name == "np_noorex_plugin");
  port_ext1.onMessage.addListener(function(msg) {
	if (!port) 
	{
		if(!connect())
			port_ext.postMessage("Connect native message host error");
	}
	sendNativeMessage(msg);
    //port_ext.postMessage(msg);
  });
  port_ext1.onDisconnect.addListener(onDisconnectedExt);
});

function sendNativeMessage(message) {
	if (!port) return;
	var msg=new String(message)
  port.postMessage(message);
}
function onNativeMessage(message) {
  //appendMessage("Received message: <b>" + JSON.stringify(message) + "</b>");
  if(port_ext) 
	port_ext.postMessage(message);
	else
	alert("Chrome connection error to NooRex messaging host. Reload page.");
}
function onDisconnected() {
  port = null;
}
function connect() {
  //appendMessage("Connecting to native messaging host <b>" + hostName + "</b>")
  port = chrome.runtime.connectNative(hostName);
  if(!port) return false;
  port.onMessage.addListener(onNativeMessage);
  port.onDisconnect.addListener(onDisconnected);
  return true;
}
